Subject: Re: Kernel 5.5.4 build fail for BPF-selftests with latest LLVM

From: Jesper Dangaard Brouer <[email-masked]>
Date: Wed, 19 Feb 2020 14:42:54 +0100

On Wed, 19 Feb 2020 14:28:56 +0100
Greg Kroah-Hartman <[email-masked]> wrote:

> On Wed, Feb 19, 2020 at 01:30:12PM +0100, Jesper Dangaard Brouer wrote:
> > Hi Andrii,
> > 
> > Downloaded tarball for kernel release 5.5.4, and I cannot compile
> > tools/testing/selftests/bpf/ with latest LLVM release version 9.  
> 
> Is this something that recently broke?  If so, what commit caused it?

Digging through, it seems several commits.

> And has llvm 9 always worked here?

Yes, llvm-9 used to work for tools/testing/selftests/bpf/.

> > Looking closer at the build error messages, I can see that this is
> > caused by using LLVM features that (I assume) will be avail in release
> > 10. I find it very strange that we can release a kernel that have build
> > dependencies on a unreleased version of LLVM.  
> 
> Is this the first time you have tried using llvm to build a kernel?
> This isn't a new thing :)

LOL - we are talking past each-other... I'm not building the entire
kernel with LLVM.  Notice I'm talking about the BPF-selftests located
in directory tools/testing/selftests/bpf/.  Building the selftests
programs are broken

We always use LLVM to build BPF programs (both samples/bpf/ and selftests).

> > I love the new LLVM BTF features, but we cannot break users/CI-systems
> > that wants to run the BPF-selftests.  

-- 
Best regards,
  Jesper Dangaard Brouer
  MSc.CS, Principal Kernel Engineer at Red Hat
  LinkedIn: http://www.linkedin.com/in/brouer